#pragma warning(disable:4786)

#ifndef __BOILER_H
#define __BOILER_H

#include "../DXObject.h"
#include "WaterSurface.h"
#include "Burbulator.h"

class CResources;
class CCamera;
struct SVertexXyzTex1;


class CBoiler : public CDXObject {
public:
	CBoiler( CResources& resources, CCamera& camera );
	~CBoiler();

	virtual HRESULT onCreateDevice( IDirect3DDevice8* device );
	virtual HRESULT onLostDevice();
	virtual HRESULT onResetDevice();
	virtual HRESULT onDestroyDevice();
	virtual void CBoiler::render( float lastFrameTime );

	bool isShowingVelocity() const { return mShowingVelocity; }
	void setShowingVelocity( bool s ) { mShowingVelocity = s; }
	bool isDrawingWireframe() const { return mDrawingWireframe; }
	void setDrawingWireframe( bool dw ) { mDrawingWireframe = dw; }
	
private:
	static D3DCOLOR getColorFromTemperature( float temp );
	static void fillParticle( SVertexXyzTex1* vb, const D3DXVECTOR3& pos, float size, const D3DXMATRIX& viewMat );

	void	createBubbleBuffers();
	void	renderVelocity( float lastFrameTime );
	
private:
	CResources*		mResources;
	CCamera*		mCamera;

	bool			mShowingVelocity;
	bool			mDrawingWireframe;
	
	CWaterSurface	mWaterSurface;
	CBurbulator		mBurbulator;
	float			mTime;

	IDirect3DVertexBuffer8*	mVBWater;
	IDirect3DIndexBuffer8*	mIBBubbles;
	IDirect3DVertexBuffer8*	mVBBubbles;
};

#endif
