
#ifndef __WATER_SURFACE_H
#define __WATER_SURFACE_H

#include <d3dx8math.h>

class CResources;


class CWaterSurface {
public:
	enum { SIZE = 32 };
	enum { LAYER_SIZE = SIZE*SIZE };
public:
	CWaterSurface( CResources& resources );

	void	feedVelocity( float x, float y, const D3DXVECTOR3& v, float deltaTime );
	void	resetVelocities();
	void	updateWaterMesh( float deltaTime );

private:
	CResources*	mResources;
	D3DXVECTOR3	mVelocities[ LAYER_SIZE ];

};

#endif
